import os
import json
import base64
import os.path as path


# protocol 1: flag{m4n_1n_th3_m1ddl3_w0w}
class Module:
    def __init__(self, incoming=False, verbose=False, options=None):
        # extract the file name from __file__. __file__ is proxymodules/name.py
        self.name = path.splitext(path.basename(__file__))[0]
        self.description = 'Simply print the received data as text'
        self.incoming = incoming  # incoming means module is on -im chain
        self.find = None  # if find is not None, this text will be highlighted

    def execute(self, data):
        print(f"Incoming data: {data}")
        data_json = json.loads(data)

        if data_json.get("type") == "HANDSHAKE":
            return data
        
        elif data_json.get("id") == 1:
            data_json["content"] = data_json["content"].replace("Bob","Eve")
        
        elif data_json.get("id") == 3:
            data_json["id"] = 4
            data_json["sender"] = "Bob"
            data_json["receiver"] = "Alice"
            data_json["content"] = str(base64.b64encode(os.urandom(16)))
        
        data = json.dumps(data_json) + "\n"
        print(f"Outgoing data: {data}")
        return data


if __name__ == '__main__':
    print('This module is not supposed to be executed alone!')
